/***************************************************************************
 *		  Copyright (C) 1994  Charles P. Peterson                  *
 *	     4007 Enchanted Sun, San Antonio, Texas 78244-1254             *
 *              Email: Charles_P_Peterson@fcircus.sat.tx.us                *
 *                                                                         *
 *		  This is free software with NO WARRANTY.                  *
 *	      See gfft.c, or run program itself, for details.              *
 *		      Support is available for a fee.                      *
 ***************************************************************************
 *
 * Program:     gfft--General FFT analysis
 * File:        okrfft.c
 * Purpose:     Do an fft on real samples.
 * Author:      Charles Peterson (CPP)
 * History:     16-August-1993 CPP; Created.
 * Comment:
 *    This driver allows the use of one of possibly several available
 *    fft algorithms--for testing or comparison.
 */

#include "gfft.h"
#include "complex.h"
#include "settings.h"

void ok_rfft (float *indata, unsigned long n)
{
#ifdef NUMERICAL_RECIPES_AVAILABLE
    if (Numerical)
    {
	realft (indata-1, n/2, FORWARD_FFT);  /* NR uses 1-based arrays */
    }
    else
#endif
    {
	rfft ((Complex_float *) indata, n, FORWARD_FFT);
    }
}
