/***************************************************************************
 *		  Copyright (C) 1994  Charles P. Peterson                  *
 *	     4007 Enchanted Sun, San Antonio, Texas 78244-1254             *
 *              Email: Charles_P_Peterson@fcircus.sat.tx.us                *
 *                                                                         *
 *		  This is free software with NO WARRANTY.                  *
 *	      See gfft.c, or run program itself, for details.              *
 *		      Support is available for a fee.                      *
 ***************************************************************************
 *
 * Program:     gfft--General FFT analysis
 * File:        wbench.h
 * Purpose:     workbench GUI definitions
 * Author:      Charles Peterson (CPP)
 * History:     5-Jan-1994 CPP; Created.
 *              4-Aug-94 CPP (1.04); Filenames may contain spaces
 * Comments:    Workbench GUI.  Amiga Dependent!
 *              There may be other toolkits.  Mine is intended to be
 *              compatible with all releases of AmigaDOS.  It was
 *              written when I only had the 1.1 RKM's.  It is very
 *              simple (I think, anyway).  The basic model is:
 *              rows of 'text buttons.'
 */

#ifdef AMIGA

char *string_gadget__apply (struct Gadget *string_gadgetp,
			    char *(*apply_function)(char *arg));

char *name_string_gadget__apply (struct Gadget *string_gadgetp,
				 char *(*apply_function)(char *arg));

void string_gadget__reset (struct Gadget *string_gadgetp,
			    char *new_string,
			    struct Window *windowp);

char *file_requestor (char *hail_message);
void open_libraries (void);

struct Border *button_border__new (short width, short top_pen, 
				   short bottom_pen);

struct IntuiText *button_text__new (char *text);
struct Gadget *text_button__new (char *text, short tcol, short trow);
void gadget__begin (int gadget_flag);

struct Gadget *gadget__new (short length, short tcol, short trow);
void gadget__enable (struct Gadget *gadgetp, struct Window *windowp);
void gadget__disable (struct Gadget *gadgetp, struct Window *windowp);


void gadget__mode (int gadget_mode);
struct Gadget *string_gadget__new (char *prompt, char *initial_name,
					  short max_chars, short length,
					  short tcol, short trow);

struct StringInfo *string_info__new (short max_chars, 
					    short vis_chars);

void refresh_gadget (struct Gadget *gadgetp, struct Window *windowp);

struct Gadget *toggle_button__new (char *text, short tcol, short trow);
void toggle_button__toggle (struct Gadget *gadgetp, 
			    char *(*on_function)(char *arg),
			    char *(*off_function)(char *arg),
			    struct Window *windowp);

struct Gadget *radio_button__new (char *text, short tcol, short trow);
void radio_button__out (struct Gadget *gadgetp, struct Window *windowp);
void radio_button__in (struct Gadget *gadgetp, 
			     struct Window *windowp);
void radio_button__toggle (struct Gadget *gadgetp, 
		     char *(*on_function)(char *arg),
		     char *(*off_function)(char *arg),
		     struct Window *windowp);

struct Gadget *message_gadget__new (short length, short tcol, short trow);
void message_gadget__write (struct Gadget *gadgetp, char *message, struct
			    Window *windowp);

struct Requester *requester__new (void);

BOOLEAN requester__display (struct Requester *rp, struct Window *wp);
void requester__remove (struct Requester *rp, struct Window *wp);



struct IntuiText *requester_text__new (char *text, short trow, short tcol);

void copyright_requester (void);
void workbench_help_requester (void);
void time3d_requester (void);
void calibration_requester (void);
void calibration_requester (void);

struct Border *border__new (short height, short width, short top_pen,
			    short bottom_pen);

struct Border *requester_border__new (short height, short width,
			    short top_pen, short bottom_pen);
#endif
